GlideinWMS - Bug #5071

glideinwms frontend & factory stopping is slow
12/10/2013 03:17 PM - Parag Mhashilkar
Description

Following was reported in the OSG JIRA:
https://jira.opensciencegrid.org/browse/SOFTWARE-1328

The init.d script for the glideinwms frontend occasionally fails when restart or start is run beca
use the glideinwms frontend is still running. The shutdown of the gwms fe takes some time but the
init.d script returns fairly quickly so on occasion when doing a restart or running the service wi
th start soon after running stop, the startup fails with a process already running error:
Traceback (most recent call last):

File "/usr/sbin/glideinFrontend", line 334, in ?

main (sys.argv[1l])

File "/usr/sbin/glideinFrontend", line 309, in main

pid_obj.register ()

File "/usr/lib/python2.4/site-packages/glideinwms/lib/pidSupport.py", line 73, in register

raise AlreadyRunning, "Another process already running"

glideinwms.lib.pidSupport.AlreadyRunning: Another process already running

As a fix, I'd suggest putting a sleep 10 or something similar in the stop function so that the gli
deinwms processes have time to shutdown.

Subtasks:
Bug # 5350: Problems invoking startup scripts as the wrong user Closed

History

#1 - 12/10/2013 03:21 PM - Igor Sfiligoi

It can occasionally take minutes for some of the sub-processes to terminate.

BTW: This is not specific to the init.d script... same experience with the frontend_startup script.

#2 - 01/08/2014 01:13 PM - Marco Mambelli

The plan is to extend the current wait time in the stop scripts and to add some check and wait in the restart procedure.
stopFrontend and stopFactory are currently inconsistent:

- stopFrontend checks no option and always tries an hard kill at the end

- stopFactory tries an hard kill only if -force is specified

| saw that the 2 scripts behave differently:

- the factory script allows a soft kill followed optionally by a hard kill (force option)

- the frontend version has always the "force" option on.

| did a new branch master_5071

| updated the 2 stop scripts stopFrontend, stopFactory to be more consistent and to avoid sending multiple signals in a loop
and updated the init scripts factory_initd_startup_template, frontend_initd_startup_template to wait up to 30 sec if shutdown is not complete and then
print a warning message.

| still want to compare the RPM init scripts so that a single template can be used for both

#3 - 02/06/2014 09:41 AM - Parag Mhashilkar

- Subject changed from glideinwms frontend init.d script occasionally fails to glideinwms frontend & factory stopping is slow
#4 - 02/21/2014 06:58 PM - Marco Mambelli

Changes solving all the issues (except single template for startup scripts) committed.
| did a test installing on one node using the git branch master_5071
Preliminary test works correctly.

Monday will review the RPM startup scripts together with Parag, trying to produce them form the templates used for the tarball installation.

Than testing and review

PS Category is wrong. Changes affect Factory and Frontend, both tarball and RPM

#5 - 03/24/2014 01:29 PM - Marco Mambelli
- File glideinwms.spec added
- Status changed from New to Feedback

- Assignee changed from Marco Mambelli to Parag Mhashilkar

The changes address:
- 5071
-5106
-5148
- 5350

| committed the changes tested them in a tarball installation and tested the generation or the RPM version of the init.d files.
Ready for review. Assigning it to Parag

| was not able to commit the spec file which is attached to the ticket.
I sent an email to Tim C. to verify my access to the VDT SVN server.

#6 - 03/25/2014 02:07 PM - Marco Mambelli
I committed the new spec file (the file attached) to the OSG SVN repository

#7 - 03/31/2014 02:58 PM - Marco Mambelli
Committed revision 19046 to the OSG SVN repository
- changes to build from the template in master_5071 (or master_5071_5351)

- fixed the factory condor config (now using 00_gwms_factory_general.config that contains "QUEUE_SUPER_USERS =
$(QUEUE_SUPER_USERS), wmsfactory")

#8 - 03/31/2014 03:26 PM - Parag Mhashilkar

- Assignee changed from Parag Mhashilkar to Marco Mambelli

Created a new branch v3/5071_v2 thats rebased against branch_v3_2. Reviewed and sent feedback to Marco.

#9 - 04/02/2014 04:12 PM - Marco Mambelli

- Status changed from Feedback to Resolved

See 5071 for details. Merged in branch_v3_2, ready for v3_2_4rc1 release
Leaving the tcket Resolved and not closed until the release.

#10 - 04/15/2014 11:23 AM - Parag Mhashilkar

Closing the issues that were take care of in v3.2.4

#11 - 04/15/2014 11:23 AM - Parag Mhashilkar

- Status changed from Resolved to Closed

Files
glideinwms.spec 41.1 KB 03/24/2014 Marco Mambelli
